unit TvorbaRozvrhu_unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Central_unit;

type
  TPPredmet2 = ^TPredmet2;
  TPredmet2 = record
             Zkratka: String[5];
             Vyucuje: String[30];
             PozadovanaUcebna: String[5];
             Dvouhodinovka:Boolean;
             CelaTrida: Boolean;
             Zaci: set of Byte;
             Trida : String[5];
             Tridni: String[30];
             KmenovaUcebna: String[5];
             PocetZaku:Byte;
             ZkratkaUcitele: String[10];
             Hodiny: THodinySet;
             Dalsi: TPPredmet2;
             end;

  TZasobnik = class(TObject)
            Vrchol: TPPredmet2;
            Pocet: Word;
            constructor Create;
            destructor  Done;
            procedure Napln(Tridy:TPTrida);
            procedure Pop(var Pr:TPPredmet2);
            function  Push:TPPredmet2;
            function  Prazdno: Boolean;
            procedure Zamichej;
            end;

  TPole = array[Po..Pa,1..10] of TPPredmet2;
  TPNazevTridy = ^TNazevTridy;
  TNazevTridy = record
              Jmeno: String[5];
              Dalsi: TPNazevTridy;
              end;

  TRozvrh = class(TObject)
          Pole: TPole;
          Hodnota:Integer;
          constructor Create;
          destructor  Done;
          procedure Vyprazdni(var Prvni:TPPredmet2);
                 {Pedan pointer nastav na nil a vechno kam ukazoval odstran}
          function LzeZaradit(Den:TDny;Hodina:Byte;Predmet:TPPredmet2):Boolean;
          function LzeZaradit2(Den:TDny;Hodina:Byte;Predmet:TPPredmet2):Boolean;
                 {Testuje vztahy mezi Predmetem a ostatnmi v danou hodinu}
          function NeniVTenDen(Den:TDny;Predmet:TPPredmet2):Boolean;
          procedure Vloz(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
                    {Kontroluje dvouhodinovky}
          procedure Vloz2(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
                    {Nekontroluje dvouhodinovky}
          procedure Odstran(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
          function  VratPointer(Den:TDny;Hodina:Byte;Trida:String):TPPredmet2;
          function  VratPointerDalsi(Uk:TPPredmet2;Trida:String):TPPredmet2;
          function  VypisPocetPredmetu(Den:TDny;Hodina:Byte;Trida:String):Byte;
          procedure Kopiruj(R:TRozvrh);
          procedure Spoctihodnotu;
          function  SpoctihodnotuMezeryZaci(Priorita:Byte):integer;
          function  SpoctihodnotuMezeryUcitele(Priorita:Byte):integer;
          function  SpoctihodnotuZacatekPrvni(Priorita:Byte):integer;
          function  SpoctihodnotuMaloOd(Hodina:Byte;Priorita:Byte):integer;
          procedure Uloz;
          procedure Napln;
          function  VratSeznamNazvuTrid:TPNazevTridy;
          end;

   Procedure Akce;
     {Vlastn procedura volan stisknutm tlatka "Vytvo Rozvrh"}
   Procedure Tvorba;
   Procedure Zarad(Den:TDny;Hodina:Byte;Predmet:TPPredmet2);
     {Rekurzivn se vol a tvo rozvrh}

var Zasobnik: TZasobnik;
    Rozvrh:   TRozvrh;
    RozvrhKopie:TRozvrh;
    Hotovo:Boolean;
    PocetBezeZmeny:Int64;
    NeoznamenoMnoho:Boolean;
    Chyba:Boolean;
    PocetProjiti:Cardinal;

implementation

uses VysledkyVyberTridy_unit, Vysledky_unit, VytvarimRozvrh_unit;

constructor TZasobnik.Create;
begin
Vrchol := nil;
Pocet := 0;
end;

destructor TZasobnik.Done;
var Uk: TPPredmet2;
begin
  while Vrchol <> nil do
    begin
      Uk := Vrchol;
      Vrchol := Vrchol.Dalsi;
      dispose(Uk);
    end;
end;

procedure TZasobnik.Napln(Tridy:TPTrida);
var Pr: TPPredmet;
    Novy: TPPredmet2;
    i:Byte;
begin
  While Tridy <> nil do
    begin
      Pr := Tridy.Predmety;
      If Pr = nil then
         begin
           If MessageDlg('U tdy '+Tridy.Jmeno+' nen zadn ani jeden pedmt. Chcete pokraovat?',
                       mtCustom, [mbYes, mbNo], 0) = mrNo
               then
                 begin
                   Chyba := True;
                 end;
         end;
      while Pr <> nil do
        begin
          for i := 1 to Pr.Kolikrat do
            begin
              new(Novy);
              Novy.Zkratka := Pr.Zkratka;
              If Pr.Vyucuje = '' then
                begin
                  MessageDlg('Ve td '+Tridy.Jmeno+' u pedmtu '+Pr.Zkratka+' nen zadn vyuujc!',
                             mtCustom, [mbOK], 0);
                  Chyba := True;
                  dispose(Novy);
                  Break;
                end;
              Novy.Vyucuje := Pr.Vyucuje;
              Novy.PozadovanaUcebna := Pr.PozadovanaUcebna;
              Novy.Dvouhodinovka := Pr.Dvouhodinovka;
              Novy.CelaTrida := Pr.CelaTrida;
              Novy.Zaci := Pr.Zaci;
              Novy.Dalsi := nil;
              Novy.Trida := Tridy.Jmeno;
              Novy.Tridni := Tridy.Tridni;
              Novy.KmenovaUcebna := Tridy.KmenovaUcebna;
              If Tridy.PocetZaku = 0 then
                begin
                  If MessageDlg('U tdy '+Tridy.Jmeno+' je zadn poet k 0. Chcete pokraovat?',
                             mtCustom, [mbYes, mbNo], 0) = mrNo
                      then
                        begin
                          Chyba := True;
                          dispose(Novy);
                          Break;
                        end;
                end;
              Novy.PocetZaku := Tridy.PocetZaku;
              Novy.ZkratkaUcitele := SeznamUcitelu.VypisZkratku(Pr.Vyucuje);
              Novy.Hodiny := SeznamUcitelu.VypisHodiny(Pr.Vyucuje);
              Pop(Novy);
            end;
        If Chyba then Break;
        Pr := Pr.Dalsi;
        end;
      If Chyba then Break;
      Tridy := Tridy.Dalsi;
    end;
end;

Procedure TZasobnik.Pop(var Pr:TPPredmet2);
begin
  Pr.Dalsi := Vrchol;
  Vrchol := Pr;
  Inc(Pocet);
end;

function TZasobnik.Push:TPPredmet2;
var Pr:TPPredmet2;
begin
  If Prazdno then Push := nil else
  begin
  Pr := Vrchol;
  Vrchol := Vrchol.Dalsi;
  Push := Pr;
  Dec(Pocet);
  end;
end;

function TZasobnik.Prazdno:Boolean;
begin
  If Vrchol = nil then Prazdno := True else Prazdno := False;
end;

procedure TZasobnik.Zamichej;
var PomZas:TZasobnik;
    Pr,PrPred:TPPredmet2;
    i     :integer;
begin
  PomZas := TZasobnik.Create;
  While Pocet > 0 do
    begin
      Pr := Vrchol;
      PrPred := nil;
      for i := 1 to Random(Pocet) do
          begin
            PrPred := Pr;
            Pr := Pr.Dalsi;
          end;
      if PrPred = nil then Vrchol := Vrchol.Dalsi
                      else PrPred.Dalsi := Pr.Dalsi;
      Dec(Pocet);
      PomZas.Pop(Pr);
    end;
  Vrchol := PomZas.Vrchol;
  Pocet := PomZas.Pocet;
  PomZas.Vrchol := nil;
  PomZas.Pocet := 0;
  PomZas.Done;
end;

constructor TRozvrh.Create;
var i:TDny;
    j:Byte;
begin
Hodnota := MaxInt;
For i := Po to Pa do
    begin
      for j := 1 to 10 do
          begin
            Pole[i,j] := nil;
          end;
    end;
end;

destructor TRozvrh.Done;
var i:TDny;
    j:Byte;
begin
For i := Po to Pa do
    begin
      for j := 1 to 10 do
          begin
            Vyprazdni(Pole[i,j]);
          end;
    end;
end;

procedure TRozvrh.Vyprazdni(var Prvni:TPPredmet2);
var Pr:TPPredmet2;
begin
  While Prvni <> nil do
    begin
      Pr := Prvni;
      Prvni := Prvni.Dalsi;
      dispose(Pr);
    end;
end;

function TRozvrh.LzeZaradit(Den:TDny;Hodina:Byte;Predmet:TPPredmet2):Boolean;
begin
  if Predmet.Dvouhodinovka then
                           begin
                             If (Hodina < 10) AND LzeZaradit2(Den,Hodina,Predmet)
                                AND LzeZaradit2(Den,Hodina + 1,Predmet) then
                                LzeZaradit := True else LzeZaradit := False;
                           end
                         else
                           begin
                             LzeZaradit := LzeZaradit2(Den,Hodina,Predmet);
                           end;
end;

function TRozvrh.LzeZaradit2(Den:TDny;Hodina:Byte;Predmet:TPPredmet2):Boolean;
var Pr:TPPredmet2;
    i: Byte;
begin
  LzeZaradit2 := True;
  Case Den of
       Po: begin
             Case Hodina of
                  1:  If not (Po1 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  2:  If not (Po2 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  3:  If not (Po3 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  4:  If not (Po4 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  5:  If not (Po5 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  6:  If not (Po6 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  7:  If not (Po7 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  8:  If not (Po8 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  9:  If not (Po9 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  10: If not (Po10 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  end;
           end;
       Ut: begin
             Case Hodina of
                  1:  If not (Ut1 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  2:  If not (Ut2 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  3:  If not (Ut3 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  4:  If not (Ut4 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  5:  If not (Ut5 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  6:  If not (Ut6 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  7:  If not (Ut7 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  8:  If not (Ut8 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  9:  If not (Ut9 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  10: If not (Ut10 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  end;
           end;
       St: begin
             Case Hodina of
                  1:  If not (St1 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  2:  If not (St2 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  3:  If not (St3 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  4:  If not (St4 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  5:  If not (St5 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  6:  If not (St6 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  7:  If not (St7 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  8:  If not (St8 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  9:  If not (St9 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  10: If not (St10 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  end;
           end;
       Ct: begin
             Case Hodina of
                  1:  If not (Ct1 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  2:  If not (Ct2 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  3:  If not (Ct3 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  4:  If not (Ct4 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  5:  If not (Ct5 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  6:  If not (Ct6 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  7:  If not (Ct7 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  8:  If not (Ct8 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  9:  If not (Ct9 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  10: If not (Ct10 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  end;
           end;
       Pa: begin
             Case Hodina of
                  1:  If not (Pa1 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  2:  If not (Pa2 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  3:  If not (Pa3 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  4:  If not (Pa4 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  5:  If not (Pa5 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  6:  If not (Pa6 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  7:  If not (Pa7 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  8:  If not (Pa8 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  9:  If not (Pa9 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  10: If not (Pa10 in Predmet.Hodiny) then begin LzeZaradit2 := False; Exit; end;
                  end;
           end;
       end;  {of Case (Vech)}

  Pr := Pole[Den,Hodina];
  while Pr <> nil do
    begin
      If Pr.Vyucuje = Predmet.Vyucuje then begin LzeZaradit2 := False; Break; end;
      If (Pr.PozadovanaUcebna = Predmet.PozadovanaUcebna) AND
         (Pr.PozadovanaUcebna <> '') then begin LzeZaradit2 := False; Break; end;
      If Pr.Trida = Predmet.Trida then
         begin
           If Pr.CelaTrida OR Predmet.CelaTrida then begin LzeZaradit2 := False; Break; end;
           For i := 1 to Pr.PocetZaku do
               begin
                 If (i in Pr.Zaci) AND (i in Predmet.Zaci) then begin LzeZaradit2 := False; Exit; end;
               end;
         end;

      Pr := Pr.Dalsi;
    end;
end;

function TRozvrh.NeniVTenDen(Den:TDny;Predmet:TPPredmet2):Boolean;
var Pr:TPPredmet2;
    Hodina:Byte;
begin
  NeniVTenDen := True;
  for Hodina := 1 to 10 do
    begin
      Pr := Pole[Den,Hodina];
      while Pr <> nil do
        begin
          If (Pr.Zkratka = Predmet.Zkratka) AND
             (Pr.Trida = Predmet.Trida) then begin NeniVTenDen := False; Exit; end;
          Pr := Pr.Dalsi;
        end;
    end;
end;

procedure TRozvrh.Vloz(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
var Predmet2:TPPredmet2;
begin
  if Predmet.Dvouhodinovka then
                           begin
                           Predmet.Dalsi := Pole[Den,Hodina];
                           Pole[Den,Hodina] := Predmet;
                           new(Predmet2);
                           Predmet2.Zkratka := Predmet.Zkratka;
                           Predmet2.Vyucuje := Predmet.Vyucuje;
                           Predmet2.PozadovanaUcebna := Predmet.PozadovanaUcebna;
                           Predmet2.Dvouhodinovka := Predmet.Dvouhodinovka;
                           Predmet2.CelaTrida := Predmet.CelaTrida;
                           Predmet2.Zaci := Predmet.Zaci;
                           Predmet2.Trida := Predmet.Trida;
                           Predmet2.Tridni := Predmet.Tridni;
                           Predmet2.KmenovaUcebna := Predmet.KmenovaUcebna;
                           Predmet2.PocetZaku := Predmet.PocetZaku;
                           Predmet2.ZkratkaUcitele := Predmet.ZkratkaUcitele;
                           Predmet2.Hodiny := Predmet.Hodiny;
                           Predmet2.Dalsi := Pole[Den,Hodina + 1];
                           Pole[Den,Hodina + 1] := Predmet2;
                           end
                         else
                           begin
                           Predmet.Dalsi := Pole[Den,Hodina];
                           Pole[Den,Hodina] := Predmet;
                           end;
end;

procedure TRozvrh.Vloz2(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
begin
Predmet.Dalsi := Pole[Den,Hodina];
Pole[Den,Hodina] := Predmet;
end;

procedure TRozvrh.Odstran(Den:TDny;Hodina:Byte;var Predmet:TPPredmet2);
var Uk1, Uk2: TPPredmet2;
begin
  Uk2 := Pole[Den,Hodina];
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Predmet <> Uk2)
        do
          begin
            Uk1 := Uk2;
            Uk2 := Uk2.Dalsi;
          end;
      If Uk1 = nil then Pole[Den,Hodina] := Uk2.Dalsi else
                      Uk1.Dalsi := Uk2.Dalsi;
      Uk2.Dalsi := nil;
    end;

  If Predmet.Dvouhodinovka then
    begin
      Uk2 := Pole[Den,Hodina + 1];
      Uk1 := nil;
      If Uk2 <> nil then
        begin
          While (Uk2.Dalsi <> nil) AND
                  ((Uk2.Zkratka         <> Predmet.Zkratka)
                OR (Uk2.Vyucuje         <> Predmet.Vyucuje)
                OR (Uk2.PozadovanaUcebna<> Predmet.PozadovanaUcebna)
                OR (Uk2.Dvouhodinovka   <> Predmet.Dvouhodinovka)
                OR (Uk2.CelaTrida       <> Predmet.CelaTrida)
                OR (Uk2.Zaci            <> Predmet.Zaci)
                OR (Uk2.Trida           <> Predmet.Trida)
                OR (Uk2.Tridni          <> Predmet.Tridni)
                OR (Uk2.KmenovaUcebna   <> Predmet.KmenovaUcebna)
                OR (Uk2.PocetZaku       <> Predmet.PocetZaku)
                OR (Uk2.ZkratkaUcitele  <> Predmet.ZkratkaUcitele)
                OR (Uk2.Hodiny          <> Predmet.Hodiny))
            do
              begin
                Uk1 := Uk2;
                Uk2 := Uk2.Dalsi;
              end;
          If Uk1 = nil then Pole[Den,Hodina + 1] := Uk2.Dalsi else
                          Uk1.Dalsi := Uk2.Dalsi;
          Uk2.Dalsi := nil;
          dispose(Uk2);
        end;
    end;
end;

function  TRozvrh.VratPointer(Den:TDny;Hodina:Byte;Trida:String):TPPredmet2;
var Uk:TPPredmet2;
begin
Uk := Pole[Den,Hodina];
VratPointer := nil;
While (Uk <> nil) AND (Uk.Trida <> Trida) do Uk := Uk.Dalsi;
If (Uk <> nil) AND (Uk.Trida = Trida) then VratPointer := Uk;
end;

function TRozvrh.VratPointerDalsi(Uk:TPPredmet2;Trida:String):TPPredmet2;
begin
VratPointerDalsi := nil;
If Uk <> nil then Uk := Uk.Dalsi;
While (Uk <> nil) AND (Uk.Trida <> Trida) do Uk := Uk.Dalsi;
If (Uk <> nil) AND (Uk.Trida = Trida) then VratPointerDalsi := Uk;
end;


function  TRozvrh.VypisPocetPredmetu(Den:TDny;Hodina:Byte;Trida:String):Byte;
var Pocet:Byte;
    Uk:TPPredmet2;
begin
Pocet := 0;
Uk := Pole[Den,Hodina];
While (Uk <> nil) do
  begin
    If (Uk.Trida = Trida) then Pocet := Pocet + 1;
    Uk := Uk.Dalsi;
  end;
VypisPocetPredmetu := Pocet;
end;

procedure TRozvrh.Kopiruj(R:TRozvrh);
var i: TDny;
    j: Byte;
    Uk,Novy : TPPredmet2;
begin
  Hodnota := R.Hodnota;
  for i := Po to Pa do
      for j := 1 to 10 do
          begin
            Vyprazdni(Pole[i,j]);
            Uk := R.Pole[i,j];
            While Uk <> nil do
              begin
                new(Novy);
                Novy.Zkratka := Uk.Zkratka;
                Novy.Vyucuje := Uk.Vyucuje;
                Novy.PozadovanaUcebna := Uk.PozadovanaUcebna;
                Novy.CelaTrida := Uk.CelaTrida;
                Novy.Zaci := Uk.Zaci;
                Novy.Dalsi := nil;
                Novy.Trida := Uk.Trida;
                Novy.Tridni := Uk.Tridni;
                Novy.KmenovaUcebna := Uk.KmenovaUcebna;
                Novy.PocetZaku := Uk.PocetZaku;
                Novy.ZkratkaUcitele := Uk.ZkratkaUcitele;
                Novy.Hodiny := Uk.Hodiny;
                Vloz(i,j,Novy);
                Uk := Uk.Dalsi;
              end;
          end;
end;

procedure TRozvrh.Spoctihodnotu;
begin
  Hodnota := 0;
  Hodnota :=   SpoctihodnotuMezeryZaci(SeznamPriorit.VypisPocetMezerZaci)
             + SpoctihodnotuMezeryUcitele(SeznamPriorit.VypisPocetMezerUcitele)
             + SpoctihodnotuZacatekPrvni(SeznamPriorit.VypisZacatekPrvni)
             + SpoctihodnotuMaloOd(SeznamPriorit.MaloOdHodina,SeznamPriorit.VypisMaloOd)
end;

function TRozvrh.SpoctihodnotuMezeryZaci(Priorita:Byte):integer;
var x:integer;
    i:TDny;
    j,Zacatek,Konec,k:Byte;
    Trida: TPTrida;
    UkPr:TPPredmet2;
    ZacatekNalezen, KonecNalezen, Mezera:Boolean;
begin
  x := 0;
  Trida := SeznamTrid.Prvni;
  While Trida <> nil do
    begin
      for i := Po to Pa do
        begin
           for j := 1 to Trida.PocetZaku do
             begin
               Zacatek := 1; Konec := 10;
               ZacatekNalezen := False; KonecNalezen := False;
               While Zacatek < 10 do
                 begin
                   UkPr := Pole[i,Zacatek];
                   While UkPr <> nil do
                     begin
                       If (UkPr.Trida = Trida.Jmeno) AND (UkPr.CelaTrida OR (j in UkPr.Zaci)) then
                                           begin ZacatekNalezen := True; Break; end;
                       UkPr := UkPr.Dalsi;
                     end;
                   If not ZacatekNalezen then Zacatek := Zacatek + 1 else Break;
                 end;
               While Konec > 1 do
                 begin
                   UkPr := Pole[i,Konec];
                   While UkPr <> nil do
                     begin
                       If (UkPr.Trida = Trida.Jmeno) AND (UkPr.CelaTrida OR (j in UkPr.Zaci)) then
                                           begin KonecNalezen := True; Break; end;
                       UkPr := UkPr.Dalsi;
                     end;
                   If not KonecNalezen then Konec := Konec - 1 else Break;
                 end;
               If ZacatekNalezen then
                 begin
                   For k := Zacatek to Konec do
                     begin
                       UkPr := Pole[i,k];
                       Mezera := True;
                       While UkPr <> nil do
                         begin
                           If (UkPr.Trida = Trida.Jmeno) AND (UkPr.CelaTrida OR (j in UkPr.Zaci)) then
                                               begin Mezera := False; Break; end;
                           UkPr := UkPr.Dalsi;
                         end;
                       If Mezera then x := x + Priorita;
                     end;
                 end;
             end;
        end;
      Trida := Trida.Dalsi;
    end;
  SpoctihodnotuMezeryZaci := x;
end;

function TRozvrh.SpoctihodnotuMezeryUcitele(Priorita:Byte):integer;
var x:integer;
    i:TDny;
    Zacatek,Konec,k:Byte;
    Ucitel: TPUcitel;
    UkPr:TPPredmet2;
    ZacatekNalezen, KonecNalezen, Mezera:Boolean;
begin
  x := 0;
  Ucitel := SeznamUcitelu.Prvni;
  While Ucitel <> nil do
    begin
      for i := Po to Pa do
        begin
          Zacatek := 1; Konec := 10;
          ZacatekNalezen := False; KonecNalezen := False;
          While Zacatek < 10 do
            begin
              UkPr := Pole[i,Zacatek];
              While UkPr <> nil do
                begin
                  If UkPr.Vyucuje = Ucitel.Jmeno then
                                      begin ZacatekNalezen := True; Break; end;
                  UkPr := UkPr.Dalsi;
                end;
              If not ZacatekNalezen then Zacatek := Zacatek + 1 else Break;
            end;
          While Konec > 1 do
            begin
              UkPr := Pole[i,Konec];
              While UkPr <> nil do
                begin
                  If UkPr.Vyucuje = Ucitel.Jmeno then
                                      begin KonecNalezen := True; Break; end;
                  UkPr := UkPr.Dalsi;
                end;
              If not KonecNalezen then Konec := Konec - 1 else Break;
            end;
          If ZacatekNalezen then
            begin
              For k := Zacatek to Konec do
                begin
                  UkPr := Pole[i,k];
                  Mezera := True;
                  While UkPr <> nil do
                    begin
                      If UkPr.Vyucuje = Ucitel.Jmeno then
                                          begin Mezera := False; Break; end;
                      UkPr := UkPr.Dalsi;
                    end;
                  If Mezera then x := x + Priorita;
                end;
             end;
        end;
      Ucitel := Ucitel.Dalsi;
    end;
  SpoctihodnotuMezeryUcitele := x;
end;

function TRozvrh.SpoctihodnotuZacatekPrvni(Priorita:Byte):integer;
var x:integer;
    i:TDny;
    j:Byte;
    Trida: TPTrida;
    UkPr:TPPredmet2;
    PrvniHodina:Boolean;
begin
  x := 0;
  Trida := SeznamTrid.Prvni;
  While Trida <> nil do
    begin
      for i := Po to Pa do
        begin
           for j := 1 to Trida.PocetZaku do
             begin
               PrvniHodina := False;
                   UkPr := Pole[i,1];
                   While UkPr <> nil do
                     begin
                       If (UkPr.Trida = Trida.Jmeno) AND (UkPr.CelaTrida OR (j in UkPr.Zaci)) then
                                           begin PrvniHodina := True; Break; end;
                       UkPr := UkPr.Dalsi;
                     end;
               If (not PrvniHodina) then
                 begin
                   x := x + Priorita;
                 end;
             end;
        end;
      Trida := Trida.Dalsi;
    end;
  SpoctihodnotuZacatekPrvni := x;
end;

function  TRozvrh.SpoctihodnotuMaloOd(Hodina:Byte;Priorita:Byte):integer;
var x:integer;
    i:TDny;
    j,k:Byte;
    Trida: TPTrida;
    UkPr:TPPredmet2;
    Uceni:Boolean;
begin
  x := 0;
  Trida := SeznamTrid.Prvni;
  While Trida <> nil do
    begin
      for i := Po to Pa do
        begin
           for j := 1 to Trida.PocetZaku do
             begin
               For k := Hodina to 10 do
                 begin
                   UkPr := Pole[i,k];
                   Uceni := False;
                   While UkPr <> nil do
                     begin
                       If (UkPr.Trida = Trida.Jmeno) AND (UkPr.CelaTrida OR (j in UkPr.Zaci)) then
                                           begin Uceni := True; Break; end;
                       UkPr := UkPr.Dalsi;
                     end;
                   If Uceni then x := x + Priorita;
                 end;
             end;
        end;
      Trida := Trida.Dalsi;
    end;
  SpoctihodnotuMaloOd := x;
end;

procedure TRozvrh.Uloz;
var i:TDny;
    j:Byte;
    Pr:TPPredmet2;
    PrUloz:TPredmetNaUlozeni;
begin
  Rewrite(SouborRozvrh);
  for i := Po to Pa do
    for j := 1 to 10 do
      begin
        Pr := Pole[i,j];
        While Pr <> nil do
          begin
            PrUloz.Den := i;
            PrUloz.Hodina := j;
            PrUloz.Zkratka := Pr.Zkratka;
            PrUloz.Vyucuje := Pr.Vyucuje;
            PrUloz.PozadovanaUcebna := Pr.PozadovanaUcebna;
            PrUloz.Dvouhodinovka := Pr.Dvouhodinovka;
            PrUloz.CelaTrida := Pr.CelaTrida;
            PrUloz.Zaci := Pr.Zaci;
            PrUloz.Trida := Pr.Trida;
            PrUloz.Tridni := Pr.Tridni;
            PrUloz.KmenovaUcebna := Pr.KmenovaUcebna;
            PrUloz.PocetZaku := Pr.PocetZaku;
            PrUloz.ZkratkaUcitele := Pr.ZkratkaUcitele;
            PrUloz.Hodiny := Pr.Hodiny;
            Write(SouborRozvrh,PrUloz);
            Pr := Pr.Dalsi;
          end;
      end;
  CloseFile(SouborRozvrh);
end;

procedure TRozvrh.Napln;
var Pr:TPPredmet2;
    PrUloz:TPredmetNaUlozeni;
begin
  Reset(SouborRozvrh);
  While not EOF(SouborRozvrh) do
    begin
      Read(SouborRozvrh,PrUloz);
      new(Pr);
      Pr.Zkratka := PrUloz.Zkratka;
      Pr.Vyucuje := PrUloz.Vyucuje;
      Pr.PozadovanaUcebna := PrUloz.PozadovanaUcebna;
      Pr.Dvouhodinovka := PrUloz.Dvouhodinovka;
      Pr.CelaTrida := PrUloz.CelaTrida;
      Pr.Zaci := PrUloz.Zaci;
      Pr.Trida := PrUloz.Trida;
      Pr.Tridni := PrUloz.Tridni;
      Pr.KmenovaUcebna := PrUloz.KmenovaUcebna;
      Pr.PocetZaku := PrUloz.PocetZaku;
      Pr.ZkratkaUcitele := PrUloz.ZkratkaUcitele;
      Pr.Hodiny := PrUloz.Hodiny;
      Pr.Dalsi := nil;
      Vloz2(PrUloz.Den,PrUloz.Hodina,Pr);
    end;
  CloseFile(SouborRozvrh);
end;

function TRozvrh.VratSeznamNazvuTrid:TPNazevTridy;
var SeznamTr,Tr:TPNazevTridy;
    i:TDny;
    j:Byte;
    Pr:TPPredmet2;
    JeVSeznamu:Boolean;
begin
  SeznamTr := nil;
  For i := Po to Pa do
    For j := 1 to 10 do
      begin
        Pr := Pole[i,j];
        While Pr <> nil do
          begin
            JeVSeznamu := False;
            Tr := SeznamTr;
            While Tr <> nil do
              begin
                If Tr.Jmeno = Pr.Trida then begin JeVSeznamu := True; Break; end;
                Tr := Tr.Dalsi;
              end;
            If not JeVSeznamu then
              begin
                new(Tr);
                Tr.Jmeno := Pr.Trida;
                Tr.Dalsi := SeznamTr;
                SeznamTr := Tr;
              end;
            Pr := Pr.Dalsi;
          end;
      end;
  VratSeznamNazvuTrid := SeznamTr;
end;

procedure Tvorba;
var i:TDny;
    j:Byte;
    Pr:TPPredmet2;
    k:integer;
begin
Hotovo := False;
PocetProjiti := 0;
If Zasobnik.Prazdno then Exit
else
  begin
    For k := 1 to 100 do
      begin
        Zasobnik.Zamichej;
        Pr := Zasobnik.Push;
        for j := 1 to 10 do
            begin
              For i := Po to Pa do
                  begin
                    Zarad(i,j,Pr);
                    If Hotovo then Break;
                  end;
              If Hotovo then Break;
            end;
        Zasobnik.Pop(Pr);
      end;
  end;
try VytvarimRozvrh.Pocet.Caption := IntToStr(1 + StrToInt64(VytvarimRozvrh.Pocet.Caption));
except VytvarimRozvrh.Pocet.Caption := 'Vce ne 10 trilin...'; end;
try if (PocetBezeZmeny <> -1) AND (StrToInt64(VytvarimRozvrh.Ohodnoceni.Caption) > RozvrhKopie.Hodnota) then
       PocetBezeZmeny := 0 else PocetBezeZmeny := 1 + PocetBezeZmeny;
except PocetBezeZmeny := -1; end;
VytvarimRozvrh.Ohodnoceni.Caption := IntToStr(RozvrhKopie.Hodnota);
If PocetBezeZmeny <> -1 then VytvarimRozvrh.PocetBezeZmeny.Caption := IntToStr(PocetBezeZmeny)
                        else VytvarimRozvrh.PocetBezeZmeny.Caption := 'Vce ne 10 trilin...';
If NeoznamenoMnoho AND (PocetBezeZmeny > 1000) then
   begin
     NeoznamenoMnoho := False;
     MessageDlg('Dlouho nebyl nalezen lep rozvrh - je pravdpodobn, e se ji o mnoho nezlep.',
               mtCustom, [mbOK], 0);
   end;
If RozvrhKopie.Hodnota < MaxInt then begin
                                       VytvarimRozvrh.Ohodnoceni.Visible := True;
                                       VytvarimRozvrh.ZatimNeni.Visible := False;
                                     end;  
VytvarimRozvrh.Visible := True;
end;

procedure Zarad(Den:TDny;Hodina:Byte;Predmet:TPPredmet2);
var i:TDny;
    j:Byte;
    Pr:TPPredmet2;
begin
Inc(PocetProjiti);
If PocetProjiti > 1000000 then Hotovo := True;
If Rozvrh.LzeZaradit(Den,Hodina,Predmet) AND Rozvrh.NeniVTenDen(Den,Predmet)
   then begin
          Rozvrh.Vloz(Den,Hodina,Predmet);
          If Zasobnik.Prazdno
             then
               begin
                 Hotovo := True;
                 Rozvrh.SpoctiHodnotu;
                 If Rozvrh.Hodnota < RozvrhKopie.Hodnota then
                    RozvrhKopie.Kopiruj(Rozvrh);
               end
             else
               begin
                 Pr := Zasobnik.Push;
                 for j := 1 to 10 do
                     begin
                       For i := Po to Pa do
                           begin
                             Zarad(i,j,Pr);
                             If Hotovo then Break;
                           end;
                       If Hotovo then Break;
                     end;
                 Zasobnik.Pop(Pr);
               end;
          Rozvrh.Odstran(Den,Hodina,Predmet);
        end;
end;

Procedure Akce;
begin
VytvarimRozvrh.ZatimNeni.Visible := True;
VytvarimRozvrh.Ohodnoceni.Visible := False;
Chyba := False;
Zasobnik := TZasobnik.Create;
Zasobnik.Napln(SeznamTrid.Prvni);
If not Chyba then
  begin
    Rozvrh := TRozvrh.Create;
    RozvrhKopie := TRozvrh.Create;
    Tvorba;
    NovyRozvrh := True;
    NeoznamenoMnoho := True;
    PocetBezeZmeny := 0;
  end
 else
  begin
    Zasobnik.Done;
  end;
end;
end.
